Index: palm/trunk/SOURCE/data_output_3d.f90
===================================================================
--- palm/trunk/SOURCE/data_output_3d.f90	(revision 1539)
+++ palm/trunk/SOURCE/data_output_3d.f90	(revision 1551)
@@ -20,5 +20,8 @@
 ! Current revisions:
 ! ------------------
-! 
+! Added suppport for land surface model and radiation model output. In the course
+! of this action, the limits for vertical loops have been changed (from nzb and 
+! nzt+1 to nzb_do and nzt_do, respectively in order to allow soil model output).
+! Moreover, a new vertical grid zs was introduced.
 ! 
 ! Former revisions:
@@ -112,4 +115,7 @@
     USE kinds
     
+    USE land_surface_model_mod,                                                &
+        ONLY: m_soil, m_soil_av, nzb_soil, nzt_soil, t_soil, t_soil_av
+
     USE netcdf_control
         
@@ -130,4 +136,6 @@
     INTEGER(iwp) ::  k         !: 
     INTEGER(iwp) ::  n         !: 
+    INTEGER(iwp) ::  nzb_do    !: vertical lower limit for data output
+    INTEGER(iwp) ::  nzt_do    !: vertical upper limit for data output
     INTEGER(iwp) ::  pos       !: 
     INTEGER(iwp) ::  prec      !: 
@@ -183,8 +191,4 @@
 
 !
-!-- Allocate a temporary array with the desired output dimensions.
-    ALLOCATE( local_pf(nxlg:nxrg,nysg:nyng,nzb:nz_do3d) )
-
-!
 !-- Update the netCDF time axis
 !-- In case of parallel output, this is only done by PE0 to increase the
@@ -209,4 +213,11 @@
 !--    Store the array chosen on the temporary array.
        resorted = .FALSE.
+       nzb_do = nzb
+       nzt_do = nz_do3d
+
+!
+!--    Allocate a temporary array with the desired output dimensions.
+       ALLOCATE( local_pf(nxlg:nxrg,nysg:nyng,nzb_do:nzt_do) )
+
        SELECT CASE ( TRIM( do3d(av,if) ) )
 
@@ -223,4 +234,18 @@
              ELSE
                 to_be_resorted => lpt_av
+             ENDIF
+
+          CASE ( 'm_soil' )
+             nzb_do = nzb_soil
+             nzt_do = nzt_soil
+!
+!--          For soil model quantities, it is required to re-allocate local_pf
+             DEALLOCATE ( local_pf )
+             ALLOCATE( local_pf(nxlg:nxrg,nysg:nyng,nzb_do:nzt_do) )
+
+             IF ( av == 0 )  THEN
+                to_be_resorted => m_soil
+             ELSE
+                to_be_resorted => m_soil_av
              ENDIF
 
@@ -251,5 +276,5 @@
                 DO  i = nxlg, nxrg
                    DO  j = nysg, nyng
-                      DO  k = nzb, nz_do3d
+                      DO  k = nzb_do, nzt_do
                          local_pf(i,j,k) = tend(k,j,i)
                       ENDDO
@@ -267,5 +292,5 @@
                    DO  i = nxl, nxr
                       DO  j = nys, nyn
-                         DO  k = nzb, nz_do3d
+                         DO  k = nzb_do, nzt_do
                             number_of_particles = prt_count(k,j,i)
                             IF (number_of_particles <= 0)  CYCLE
@@ -296,5 +321,5 @@
                 DO  i = nxlg, nxrg
                    DO  j = nysg, nyng
-                      DO  k = nzb, nz_do3d
+                      DO  k = nzb_do, nzt_do
                          local_pf(i,j,k) = tend(k,j,i)
                       ENDDO
@@ -336,5 +361,5 @@
                    DO  i = nxlg, nxrg
                       DO  j = nysg, nyng
-                         DO  k = nzb, nz_do3d
+                         DO  k = nzb_do, nzt_do
                             local_pf(i,j,k) = pt(k,j,i) + l_d_cp *             &
                                                           pt_d_t(k) *          &
@@ -389,5 +414,5 @@
                    DO  i = nxl, nxr
                       DO  j = nys, nyn
-                         DO  k = nzb, nz_do3d
+                         DO  k = nzb_do, nzt_do
                             number_of_particles = prt_count(k,j,i)
                             IF (number_of_particles <= 0)  CYCLE
@@ -409,5 +434,5 @@
                 DO  i = nxlg, nxrg
                    DO  j = nysg, nyng
-                      DO  k = nzb, nz_do3d
+                      DO  k = nzb_do, nzt_do
                          local_pf(i,j,k) = tend(k,j,i)
                       ENDDO
@@ -431,5 +456,5 @@
                 DO  i = nxlg, nxrg
                    DO  j = nysg, nyng
-                      DO  k = nzb, nz_do3d
+                      DO  k = nzb_do, nzt_do
                          local_pf(i,j,k) = q(k,j,i) - ql(k,j,i)
                       ENDDO
@@ -462,4 +487,18 @@
              ENDIF
 
+          CASE ( 't_soil' )
+             nzb_do = nzb_soil
+             nzt_do = nzt_soil
+!
+!--          For soil model quantities, it is required to re-allocate local_pf
+             DEALLOCATE ( local_pf )
+             ALLOCATE( local_pf(nxlg:nxrg,nysg:nyng,nzb_do:nzt_do) )
+
+             IF ( av == 0 )  THEN
+                to_be_resorted => t_soil
+             ELSE
+                to_be_resorted => t_soil_av
+             ENDIF
+
           CASE ( 'u' )
              IF ( av == 0 )  THEN
@@ -494,5 +533,5 @@
 !--          User defined quantity
              CALL user_data_output_3d( av, do3d(av,if), found, local_pf,       &
-                                       nz_do3d )
+                                       nzb_do, nzt_do )
              resorted = .TRUE.
 
@@ -510,5 +549,5 @@
           DO  i = nxlg, nxrg
              DO  j = nysg, nyng
-                DO  k = nzb, nz_do3d
+                DO  k = nzb_do, nzt_do
                    local_pf(i,j,k) = to_be_resorted(k,j,i)
                 ENDDO
@@ -531,6 +570,6 @@
           DO  i = 0, io_blocks-1
              IF ( i == io_group )  THEN
-                WRITE ( 30 )  nxlg, nxrg, nysg, nyng, nzb, nz_do3d
-                WRITE ( 30 )  local_pf
+                WRITE ( 30 )  nxlg, nxrg, nysg, nyng, nzb_do, nzt_do
+                WRITE ( 30 )  local_pf(:,:,nzb_do:nzt_do)
              ENDIF
 #if defined( __parallel )
@@ -547,22 +586,22 @@
           IF ( nxr == nx  .AND.  nyn /= ny )  THEN
              nc_stat = NF90_PUT_VAR( id_set_3d(av), id_var_do3d(av,if),  &
-                               local_pf(nxl:nxr+1,nys:nyn,nzb:nz_do3d),  &
-                start = (/ nxl+1, nys+1, nzb+1, do3d_time_count(av) /),  &
-                count = (/ nxr-nxl+2, nyn-nys+1, nz_do3d-nzb+1, 1 /) )
+                               local_pf(nxl:nxr+1,nys:nyn,nzb_do:nzt_do),    &
+                start = (/ nxl+1, nys+1, nzb_do+1, do3d_time_count(av) /),  &
+                count = (/ nxr-nxl+2, nyn-nys+1, nzt_do-nzb_do+1, 1 /) )
           ELSEIF ( nxr /= nx  .AND.  nyn == ny )  THEN
              nc_stat = NF90_PUT_VAR( id_set_3d(av), id_var_do3d(av,if),  &
-                               local_pf(nxl:nxr,nys:nyn+1,nzb:nz_do3d),  &
-                start = (/ nxl+1, nys+1, nzb+1, do3d_time_count(av) /),  &
-                count = (/ nxr-nxl+1, nyn-nys+2, nz_do3d-nzb+1, 1 /) )
+                               local_pf(nxl:nxr,nys:nyn+1,nzb_do:nzt_do),    &
+                start = (/ nxl+1, nys+1, nzb_do+1, do3d_time_count(av) /),  &
+                count = (/ nxr-nxl+1, nyn-nys+2, nzt_do-nzb_do+1, 1 /) )
           ELSEIF ( nxr == nx  .AND.  nyn == ny )  THEN
              nc_stat = NF90_PUT_VAR( id_set_3d(av), id_var_do3d(av,if),  &
-                             local_pf(nxl:nxr+1,nys:nyn+1,nzb:nz_do3d),  &
-                start = (/ nxl+1, nys+1, nzb+1, do3d_time_count(av) /),  &
-                count = (/ nxr-nxl+2, nyn-nys+2, nz_do3d-nzb+1, 1 /) )
+                             local_pf(nxl:nxr+1,nys:nyn+1,nzb_do:nzt_do  ),  &
+                start = (/ nxl+1, nys+1, nzb_do+1, do3d_time_count(av) /),  &
+                count = (/ nxr-nxl+2, nyn-nys+2, nzt_do-nzb_do+1, 1 /) )
           ELSE
              nc_stat = NF90_PUT_VAR( id_set_3d(av), id_var_do3d(av,if),  &
-                                 local_pf(nxl:nxr,nys:nyn,nzb:nz_do3d),  &
-                start = (/ nxl+1, nys+1, nzb+1, do3d_time_count(av) /),  &
-                count = (/ nxr-nxl+1, nyn-nys+1, nz_do3d-nzb+1, 1 /) )
+                                 local_pf(nxl:nxr,nys:nyn,nzb_do:nzt_do),    &
+                start = (/ nxl+1, nys+1, nzb_do+1, do3d_time_count(av) /),  &
+                count = (/ nxr-nxl+1, nyn-nys+1, nzt_do-nzb_do+1, 1 /) )
           ENDIF
           CALL handle_netcdf_error( 'data_output_3d', 386 )
@@ -572,7 +611,7 @@
 #if defined( __netcdf )
        nc_stat = NF90_PUT_VAR( id_set_3d(av), id_var_do3d(av,if),        &
-                         local_pf(nxl:nxr+1,nys:nyn+1,nzb:nz_do3d),      &
+                         local_pf(nxl:nxr+1,nys:nyn+1,nzb_do:nzt_do),        &
                          start = (/ 1, 1, 1, do3d_time_count(av) /),     &
-                         count = (/ nx+2, ny+2, nz_do3d-nzb+1, 1 /) )
+                         count = (/ nx+2, ny+2, nzt_do-nzb_do+1, 1 /) )
        CALL handle_netcdf_error( 'data_output_3d', 446 )
 #endif
@@ -581,10 +620,9 @@
        if = if + 1
 
+!
+!--    Deallocate temporary array
+       DEALLOCATE ( local_pf )
+
     ENDDO
-
-!
-!-- Deallocate temporary array.
-    DEALLOCATE( local_pf )
-
 
     CALL cpu_log( log_point(14), 'data_output_3d', 'stop' )
Index: palm/trunk/SOURCE/flow_statistics.f90
===================================================================
--- palm/trunk/SOURCE/flow_statistics.f90	(revision 1539)
+++ palm/trunk/SOURCE/flow_statistics.f90	(revision 1551)
@@ -21,5 +21,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! Added suppport for land surface model and radiation model output.
 !
 ! Former revisions:
@@ -132,8 +132,8 @@
         
     USE cloud_parameters,                                                      &
-        ONLY :  l_d_cp, prr, pt_d_t
+        ONLY:   l_d_cp, prr, pt_d_t
         
     USE control_parameters,                                                    &
-        ONLY :  average_count_pr, cloud_droplets, cloud_physics, do_sum,       &
+        ONLY:   average_count_pr, cloud_droplets, cloud_physics, do_sum,       &
                 dt_3d, g, humidity, icloud_scheme, kappa, large_scale_forcing, &
                 large_scale_subsidence, max_pr_user, message_string, ocean,    &
@@ -143,11 +143,11 @@
         
     USE cpulog,                                                                &
-        ONLY :  cpu_log, log_point
+        ONLY:   cpu_log, log_point
         
     USE grid_variables,                                                        &
-        ONLY :  ddx, ddy
+        ONLY:   ddx, ddy
         
     USE indices,                                                               &
-        ONLY :  ngp_2dh, ngp_2dh_s_inner, ngp_3d, ngp_3d_inner, ngp_sums,      &
+        ONLY:   ngp_2dh, ngp_2dh_s_inner, ngp_3d, ngp_3d_inner, ngp_sums,      &
                 ngp_sums_ls, nxl, nxr, nyn, nys, nzb, nzb_diff_s_inner,        &
                 nzb_s_inner, nzt, nzt_diff
@@ -155,5 +155,13 @@
     USE kinds
     
+    USE land_surface_model_mod,                                                &
+        ONLY:   dots_soil, ghf_eb, land_surface, m_soil, nzb_soil, nzt_soil,   &
+                qsws_eb, qsws_liq_eb, qsws_soil_eb, qsws_veg_eb, shf_eb,       &
+                t_soil
+
     USE pegrid
+
+    USE radiation_model_mod,                                                   &
+        ONLY :  dots_rad, rad_net, rad_sw_in, radiation
     
     USE statistics
@@ -703,4 +711,18 @@
                                        qsws(j,i) * rmask(j,i,sr)  ! w"q" (w"qv")
                 ENDIF
+             ENDIF
+
+             IF ( land_surface )  THEN
+                sums_l(nzb,93,tn) = sums_l(nzb,93,tn) + ghf_eb(j,i)
+                sums_l(nzb,94,tn) = sums_l(nzb,94,tn) + shf_eb(j,i)
+                sums_l(nzb,95,tn) = sums_l(nzb,95,tn) + qsws_eb(j,i)
+                sums_l(nzb,96,tn) = sums_l(nzb,96,tn) + qsws_liq_eb(j,i)
+                sums_l(nzb,97,tn) = sums_l(nzb,97,tn) + qsws_soil_eb(j,i)
+                sums_l(nzb,98,tn) = sums_l(nzb,98,tn) + qsws_veg_eb(j,i)
+             ENDIF
+
+             IF ( radiation )  THEN
+                sums_l(nzb,99,tn)  = sums_l(nzb,99,tn)  + rad_net(j,i)
+                sums_l(nzb,100,tn) = sums_l(nzb,100,tn) + rad_sw_in(j,i)
              ENDIF
 
@@ -1074,4 +1096,18 @@
        ENDIF
 
+
+       IF ( land_surface )  THEN
+          !$OMP DO
+          DO  i = nxl, nxr
+             DO  j =  nys, nyn
+                DO  k = nzb_soil, nzt_soil
+                   sums_l(k,89,tn)  = sums_l(k,89,tn)  + t_soil(k,j,i) * rmask(j,i,sr)
+                   sums_l(k,91,tn)  = sums_l(k,91,tn)  + m_soil(k,j,i) * rmask(j,i,sr)
+                ENDDO
+             ENDDO
+          ENDDO
+       ENDIF
+       
+
 !
 !--    Calculate the user-defined profiles
@@ -1133,5 +1169,6 @@
           sums(k,70:80)           = sums(k,70:80)       / ngp_2dh_s_inner(k,sr)
           sums(k,81:88)           = sums(k,81:88)       / ngp_2dh(sr)
-          sums(k,89:pr_palm-2)    = sums(k,89:pr_palm-2)/ ngp_2dh_s_inner(k,sr)
+          sums(k,89:100)           = sums(k,89:100)     / ngp_2dh(sr)
+          sums(k,101:pr_palm-2)    = sums(k,101:pr_palm-2)/ ngp_2dh_s_inner(k,sr)
        ENDDO
 
@@ -1248,4 +1285,22 @@
        ENDIF
 
+       IF ( land_surface )  THEN
+          hom(:,1,89,sr) = sums(:,89)              ! t_soil
+                                                   ! 90 is initial t_soil profile
+          hom(:,1,91,sr) = sums(:,91)              ! m_soil
+                                                   ! 92 is initial m_soil profile
+          hom(:,1,93,sr) = sums(:,93)              ! ghf_eb
+          hom(:,1,94,sr) = sums(:,94)              ! shf_eb
+          hom(:,1,95,sr) = sums(:,95)              ! qsws_eb
+          hom(:,1,96,sr) = sums(:,96)              ! qsws_liq_eb
+          hom(:,1,97,sr) = sums(:,97)              ! qsws_soil_eb
+          hom(:,1,98,sr) = sums(:,98)              ! qsws_veg_eb
+       ENDIF
+
+       IF ( radiation )  THEN
+          hom(:,1,99 ,sr) = sums(:,99)             ! rad_net
+          hom(:,1,100,sr) = sums(:,100)            ! rad_sw_in
+       ENDIF
+
        hom(:,1,pr_palm-1,sr) = sums(:,pr_palm-1)
                                        ! upstream-parts u_x, u_y, u_z, v_x,
@@ -1392,4 +1447,22 @@
 
        ts_value(23,sr) = hom(nzb+12,1,pr_palm,sr)   ! q*
+
+!
+!--    Collect land surface model timeseries
+       IF ( land_surface )  THEN
+          ts_value(dots_soil  ,sr) = hom(nzb,1,93,sr)           ! ghf_eb
+          ts_value(dots_soil+1,sr) = hom(nzb,1,94,sr)           ! shf_eb
+          ts_value(dots_soil+2,sr) = hom(nzb,1,95,sr)           ! qsws_eb
+          ts_value(dots_soil+3,sr) = hom(nzb,1,96,sr)           ! qsws_liq_eb
+          ts_value(dots_soil+4,sr) = hom(nzb,1,97,sr)           ! qsws_soil_eb
+          ts_value(dots_soil+5,sr) = hom(nzb,1,98,sr)           ! qsws_veg_eb
+       ENDIF
+!
+!--    Collect radiation model timeseries
+       IF ( radiation )  THEN
+          ts_value(dots_rad,sr)   = hom(nzb,1,99,sr)           ! rad_net
+          ts_value(dots_rad+1,sr) = hom(nzb,1,100,sr)          ! rad_sw_in
+       ENDIF
+
 !
 !--    Calculate additional statistics provided by the user interface
@@ -2842,4 +2915,18 @@
        ENDIF
 
+
+       IF ( land_surface )  THEN
+          !$OMP DO
+          DO  i = nxl, nxr
+             DO  j =  nys, nyn
+                DO  k = nzb_soil, nzt_soil
+                   sums_l(k,89,tn)  = sums_l(k,89,tn)  + t_soil(k,j,i) * rmask(j,i,sr)
+                   sums_l(k,91,tn)  = sums_l(k,91,tn)  + m_soil(k,j,i) * rmask(j,i,sr)
+                ENDDO
+             ENDDO
+          ENDDO
+       ENDIF
+
+
 !
 !--    Calculate the user-defined profiles
@@ -2903,5 +2990,6 @@
           sums(k,70:80)           = sums(k,70:80)       / ngp_2dh_s_inner(k,sr)
           sums(k,81:88)           = sums(k,81:88)       / ngp_2dh(sr)
-          sums(k,89:pr_palm-2)    = sums(k,89:pr_palm-2)/ ngp_2dh_s_inner(k,sr)
+          sums(k,89:100)           = sums(k,89:100)     / ngp_2dh(sr)
+          sums(k,101:pr_palm-2)    = sums(k,101:pr_palm-2)/ ngp_2dh_s_inner(k,sr)
        ENDDO
 
@@ -3162,4 +3250,22 @@
 
        ts_value(23,sr) = hom(nzb+12,1,pr_palm,sr)   ! q*
+
+!
+!--    Collect land surface model timeseries
+       IF ( land_surface )  THEN
+          ts_value(dots_soil  ,sr) = hom(nzb,1,93,sr)           ! ghf_eb
+          ts_value(dots_soil+1,sr) = hom(nzb,1,94,sr)           ! shf_eb
+          ts_value(dots_soil+2,sr) = hom(nzb,1,95,sr)           ! qsws_eb
+          ts_value(dots_soil+3,sr) = hom(nzb,1,96,sr)           ! qsws_liq_eb
+          ts_value(dots_soil+4,sr) = hom(nzb,1,97,sr)           ! qsws_soil_eb
+          ts_value(dots_soil+5,sr) = hom(nzb,1,98,sr)           ! qsws_veg_eb
+       ENDIF
+!
+!--    Collect radiation model timeseries
+       IF ( radiation )  THEN
+          ts_value(dots_rad,sr)   = hom(nzb,1,99,sr)           ! rad_net
+          ts_value(dots_rad+1,sr) = hom(nzb,1,100,sr)          ! rad_sw_in
+       ENDIF
+
 !
 !--    Calculate additional statistics provided by the user interface
Index: palm/trunk/SOURCE/header.f90
===================================================================
--- palm/trunk/SOURCE/header.f90	(revision 1539)
+++ palm/trunk/SOURCE/header.f90	(revision 1551)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! Added informal output for land surface model and radiation model. Removed typo.
 ! 
 ! Former revisions:
@@ -170,5 +170,5 @@
 ! Description:
 ! ------------
-! Writing a header with all important informations about the actual run.
+! Writing a header with all important information about the actual run.
 ! This subroutine is called three times, two times at the beginning 
 ! (writing information on files RUN_CONTROL and HEADER) and one time at the
@@ -200,5 +200,10 @@
         
     USE kinds
-    
+   
+    USE land_surface_model_mod,                                                &
+        ONLY:  conserve_water_content, dewfall, land_surface, nzb_soil,        &
+               nzt_soil, root_fraction, soil_moisture, soil_temperature,       &
+               soil_type, soil_type_name, veg_type, veg_type_name, zs
+ 
     USE model_1d,                                                              &
         ONLY:  damp_level_ind_1d, dt_pr_1d, dt_run_control_1d, end_time_1d
@@ -225,4 +230,8 @@
                lai_beta, leaf_scalar_exch_coeff, leaf_surface_conc, pch_index, &
                plant_canopy
+
+    USE radiation_model_mod,                                                   &
+        ONLY:  albedo, day_init, dt_radiation, lambda, net_radiation,          &
+               radiation, radiation_scheme, time_utc_init
     
     USE spectrum,                                                              &
@@ -263,4 +272,5 @@
     CHARACTER (LEN=86) ::  gradients           !:
     CHARACTER (LEN=86) ::  leaf_area_density   !:
+    CHARACTER (LEN=86) ::  roots               !:
     CHARACTER (LEN=86) ::  slices              !:
     CHARACTER (LEN=86) ::  temperatures        !:
@@ -311,5 +321,5 @@
 !
 !-- At the end of the run, output file (HEADER) will be rewritten with
-!-- new informations
+!-- new information
     IF ( io == 19 .AND. simulated_time_at_begin /= simulated_time ) REWIND( 19 )
 
@@ -495,5 +505,5 @@
 
 !
-!-- Runtime and timestep informations
+!-- Runtime and timestep information
     WRITE ( io, 200 )
     IF ( .NOT. dt_fixed )  THEN
@@ -850,4 +860,73 @@
 
 
+    IF ( land_surface )  THEN
+
+       temperatures = ''
+       gradients    = '' ! use for humidity here
+       coordinates  = '' ! use for height
+       roots        = '' ! use for root fraction
+       slices       = '' ! use for index
+
+       i = 1
+       DO i = nzb_soil, nzt_soil
+          WRITE (coor_chr,'(F10.2,7X)') soil_temperature(i)
+          temperatures = TRIM( temperatures ) // ' ' // TRIM( coor_chr )
+
+          WRITE (coor_chr,'(F10.2,7X)') soil_moisture(i)
+          gradients = TRIM( gradients ) // ' ' // TRIM( coor_chr )
+
+          WRITE (coor_chr,'(F10.2,7X)')  - zs(i)
+          coordinates = TRIM( coordinates ) // ' '  // TRIM( coor_chr )
+
+          WRITE (coor_chr,'(F10.2,7X)')  root_fraction(i)
+          roots = TRIM( roots ) // ' '  // TRIM( coor_chr )
+
+          WRITE (coor_chr,'(I10,7X)')  i
+          slices = TRIM( slices ) // ' '  // TRIM( coor_chr )
+
+
+       ENDDO
+
+!
+!--    Write land surface model header
+       WRITE( io, 419 )
+       IF ( conserve_water_content )  THEN
+          WRITE( io, 440 )
+       ELSE
+          WRITE( io, 441 )
+       ENDIF
+
+       IF ( dewfall )  THEN
+          WRITE( io, 442 )
+       ELSE
+          WRITE( io, 443 )
+       ENDIF
+
+       WRITE( io, 438 ) veg_type_name(veg_type), soil_type_name(soil_type)
+       WRITE( io, 439 ) TRIM( coordinates ), TRIM( temperatures ),             &
+                        TRIM( gradients ), TRIM( roots ), TRIM( slices )
+
+
+    ENDIF
+
+    IF ( radiation )  THEN
+!
+!--    Write land surface model header
+       WRITE( io, 444 )
+
+       IF ( radiation_scheme == "constant" )  THEN
+          WRITE( io, 445 ) net_radiation
+       ELSEIF ( radiation_scheme == "clear-sky" )  THEN
+          WRITE( io, 446 )
+       ELSE
+          WRITE( io, 447 ) radiation_scheme
+       ENDIF
+
+       WRITE( io, 448 ) albedo
+       WRITE( io, 449 ) dt_radiation
+
+    ENDIF
+
+
 !
 !-- Boundary conditions
@@ -877,9 +956,13 @@
 
     IF ( ibc_pt_b == 0 )  THEN
-       runten = TRIM( runten ) // ' pt(0)   = pt_surface'
+       IF ( land_surface )  THEN
+          runten = TRIM( runten ) // ' pt(0)     = from soil model'
+       ELSE
+          runten = TRIM( runten ) // ' pt(0)     = pt_surface'
+       ENDIF
     ELSEIF ( ibc_pt_b == 1 )  THEN
-       runten = TRIM( runten ) // ' pt(0)   = pt(1)'
+       runten = TRIM( runten ) // ' pt(0)     = pt(1)'
     ELSEIF ( ibc_pt_b == 2 )  THEN
-       runten = TRIM( runten ) // ' pt(0) = from coupled model'
+       runten = TRIM( runten ) // ' pt(0)     = from coupled model'
     ENDIF
     IF ( ibc_pt_t == 0 )  THEN
@@ -918,5 +1001,10 @@
     IF ( humidity )  THEN
        IF ( ibc_q_b == 0 )  THEN
-          runten = 'q(0)     = q_surface'
+          IF ( land_surface )  THEN
+             runten = 'q(0)     = from soil model'
+          ELSE
+             runten = 'q(0)     = q_surface'
+          ENDIF
+
        ELSE
           runten = 'q(0)     = q(1)'
@@ -1225,5 +1313,5 @@
              coordinates = '/'
 !
-!--          Building strings with index and coordinate informations of the
+!--          Building strings with index and coordinate information of the
 !--          slices
              DO  WHILE ( section(i,1) /= -9999 )
@@ -1271,5 +1359,5 @@
              coordinates = '/'
 !
-!--          Building strings with index and coordinate informations of the
+!--          Building strings with index and coordinate information of the
 !--          slices
              DO  WHILE ( section(i,2) /= -9999 )
@@ -1313,5 +1401,5 @@
              coordinates = '/'
 !
-!--          Building strings with index and coordinate informations of the
+!--          Building strings with index and coordinate information of the
 !--          slices
              DO  WHILE ( section(i,3) /= -9999 )
@@ -1571,9 +1659,16 @@
 !
 !-- Geostrophic parameters
-    WRITE ( io, 410 )  omega, phi, f, fs
+    IF ( radiation .AND. radiation_scheme /= 'constant' )  THEN
+       WRITE ( io, 417 )  lambda
+    ENDIF
+    WRITE ( io, 410 )  phi, omega, f, fs
 
 !
 !-- Other quantities
     WRITE ( io, 411 )  g
+    IF ( radiation .AND. radiation_scheme /= 'constant' )  THEN
+       WRITE ( io, 418 )  day_init, time_utc_init
+    ENDIF
+
     WRITE ( io, 412 )  TRIM( reference_state )
     IF ( use_single_reference_value )  THEN
@@ -1732,5 +1827,5 @@
 
 !
-!-- User-defined informations
+!-- User-defined information
     CALL user_header( io )
 
@@ -1867,6 +1962,6 @@
 260 FORMAT (/' The model has a slope in x-direction. Inclination angle: ',F6.2,&
              ' degrees')
-270 FORMAT (//' Topography informations:'/ &
-              ' -----------------------'// &
+270 FORMAT (//' Topography information:'/ &
+              ' ----------------------'// &
               1X,'Topography: ',A)
 271 FORMAT (  ' Building size (x/y/z) in m: ',F5.1,' / ',F5.1,' / ',F5.1/ &
@@ -1905,5 +2000,5 @@
              ' -------------------'// &
              '                     p                    uv             ', &
-             '                   pt'// &
+             '                     pt'// &
              ' B. bound.: ',A/ &
              ' T. bound.: ',A)
@@ -2047,19 +2142,24 @@
 400 FORMAT (//' Physical quantities:'/ &
               ' -------------------'/)
-410 FORMAT ('    Angular velocity    :   omega = ',E9.3,' rad/s'/  &
-            '    Geograph. latitude  :   phi   = ',F4.1,' degr'/   &
-            '    Coriolis parameter  :   f     = ',F9.6,' 1/s'/    &
-            '                            f*    = ',F9.6,' 1/s')
-411 FORMAT (/'    Gravity             :   g     = ',F4.1,' m/s**2')
+410 FORMAT ('    Geograph. latitude  :   phi    = ',F4.1,' degr'/   &
+            '    Angular velocity    :   omega  = ',E9.3,' rad/s'/  &
+            '    Coriolis parameter  :   f      = ',F9.6,' 1/s'/    &
+            '                            f*     = ',F9.6,' 1/s')
+411 FORMAT (/'    Gravity             :   g      = ',F4.1,' m/s**2')
 412 FORMAT (/'    Reference state used in buoyancy terms: ',A)
 413 FORMAT ('       Reference density in buoyancy terms: ',F8.3,' kg/m**3')
 414 FORMAT ('       Reference temperature in buoyancy terms: ',F8.4,' K')
-415 FORMAT (/'    Cloud physics parameters:'/ &
-             '    ------------------------'/)
-416 FORMAT ('        Surface pressure   :   p_0   = ',F7.2,' hPa'/      &
-            '        Gas constant       :   R     = ',F5.1,' J/(kg K)'/ &
-            '        Density of air     :   rho_0 = ',F5.3,' kg/m**3'/  &
-            '        Specific heat cap. :   c_p   = ',F6.1,' J/(kg K)'/ &
-            '        Vapourization heat :   L_v   = ',E8.2,' J/kg')
+415 FORMAT (/' Cloud physics parameters:'/ &
+             ' ------------------------'/)
+416 FORMAT ('    Surface pressure   :   p_0   = ',F7.2,' hPa'/      &
+            '    Gas constant       :   R     = ',F5.1,' J/(kg K)'/ &
+            '    Density of air     :   rho_0 = ',F5.3,' kg/m**3'/  &
+            '    Specific heat cap. :   c_p   = ',F6.1,' J/(kg K)'/ &
+            '    Vapourization heat :   L_v   = ',E8.2,' J/kg')
+417 FORMAT ('    Geograph. longitude :   lambda = ',F4.1,' degr')
+418 FORMAT (/'    Day of the year at model start :   day_init      =     ',I3 &
+            /'    UTC time at model start        :   time_utc_init = ',F7.1' s')
+419 FORMAT (//' Land surface model information:'/ &
+              ' ------------------------------'/)
 420 FORMAT (/'    Characteristic levels of the initial temperature profile:'// &
             '       Height:        ',A,'  m'/ &
@@ -2120,4 +2220,25 @@
                        '[0,1000] cm**2/s**3')
 437 FORMAT ('    Droplet collision is switched off')
+438 FORMAT (' --> Land surface type  : ',A,/ &
+            ' --> Soil porosity type : ',A)
+439 FORMAT (/'    Initial soil temperature and moisture profile:'// &
+            '       Height:        ',A,'  m'/ &
+            '       Temperature:   ',A,'  K'/ &
+            '       Moisture:      ',A,'  m**3/m**3'/ &
+            '       Root fraction: ',A,'  '/ &
+            '       Gridpoint:     ',A)
+440 FORMAT (/' --> Dewfall is allowed (default)')
+441 FORMAT (' --> Dewfall is inhibited')
+442 FORMAT (' --> Soil bottom is closed (water content is conserved, default)')
+443 FORMAT (' --> Soil bottom is open (water content is not conserved)')
+444 FORMAT (//' Radiation model information:'/                                 &
+              ' ----------------------------'/)
+445 FORMAT (' --> Using constant net radiation: net_radiation = ', F6.2, '  W/m**2')
+446 FORMAT (' --> Simple radiation scheme for clear sky is used (no clouds,',  &
+                   ' default)')
+447 FORMAT (' --> Radiation scheme:', A)
+448 FORMAT (/'    Surface albedo: albedo = ', F5.3)
+449 FORMAT  ('    Timestep: dt_radiation = ', F5.2, '  s')
+
 450 FORMAT (//' LES / Turbulence quantities:'/ &
               ' ---------------------------'/)
@@ -2200,6 +2321,6 @@
 508 FORMAT ('    Ventilation effects on evaporation of rain drops')
 509 FORMAT ('    Slope limiter used for sedimentation process')
-510 FORMAT ('        Droplet density    :   N_c   = ',F6.1,' 1/cm**3')
-511 FORMAT ('        Sedimentation Courant number:                  '/&
+510 FORMAT ('    Droplet density    :   N_c   = ',F6.1,' 1/cm**3')
+511 FORMAT ('    Sedimentation Courant number:                  '/&
             '                               C_s   = ',F3.1,'        ')
 512 FORMAT (/' Date:                 ',A8,6X,'Run:       ',A20/      &
Index: palm/trunk/SOURCE/init_3d_model.f90
===================================================================
--- palm/trunk/SOURCE/init_3d_model.f90	(revision 1539)
+++ palm/trunk/SOURCE/init_3d_model.f90	(revision 1551)
@@ -20,5 +20,6 @@
 ! Current revisions:
 ! ------------------
-! 
+! Allocation of land surface arrays is now done in the subroutine init_lsm_arrays,
+! which is part of land_surface_model.
 ! 
 ! Former revisions:
@@ -218,5 +219,5 @@
 
     USE land_surface_model_mod,                                                &
-        ONLY:  init_lsm, land_surface
+        ONLY:  init_lsm, init_lsm_arrays, land_surface
   
     USE ls_forcing_mod
@@ -621,4 +622,10 @@
 
 !
+!-- Allocate land surface model arrays
+    IF ( land_surface )  THEN
+       CALL init_lsm_arrays
+    ENDIF
+
+!
 !-- Allocate arrays containing the RK coefficient for calculation of 
 !-- perturbation pressure and turbulent fluxes. At this point values are
